/*
 * cookie.js - store and retrieve cookies.
 *
 * Verlof Web application
 *
 * Copyright (c) 2002, by Leiden University.
 * verlof is free software.  See the file Copying for copying permission.
 *
 * $Revision: 1.2 $
 * $Date: 2003-01-29 09:20:44+01 $
 * $Source: \\\\fwneld\\msdos\\RCS\\K\\fsc\\prj\\verlof\\src\\lib\\cookie.js,v $
 * %Author: M.J. Moene %
 */

/*
 * $Header: \\\\fwneld\\msdos\\RCS\\K\\fsc\\prj\\verlof\\src\\lib\\cookie.js,v 1.2 2003-01-29 09:20:44+01 moene Exp $
 *
 * $Log: cookie.js,v $
 * Revision 1.2  2003-01-29 09:20:44+01  moene
 * <>
 *
 * Revision 1.1  2002/05/13 09:17:11  moene
 * Initial revision
 *
 */

/*
 * setCookie - set cookie values. Expiration date is optional.
 */

function setCookie(name, value, expire)
{
   document.cookie = name + "=" + escape(value) + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
}

/*
 * getCookie - get cookie value.
 */

function getCookie(name)
{
   var search = name + "=";

   if (document.cookie.length > 0)      // if there are any cookies
   {
      offset = document.cookie.indexOf(search);

      if (offset != -1)                 // if cookie exists
      {
         offset += search.length;

         // set index of beginning of value
         end = document.cookie.indexOf(";", offset);

         // set index of end of cookie value
         if (end == -1)
            end = document.cookie.length;

         return unescape(document.cookie.substring(offset, end));
      }

      return "";
   }

   return "";
}

/*
 * End of file
 */

