/*
 * register.js - registration form JavaScript.
 *
 * Verlof Web application
 *
 * Copyright (c) 2002, by Leiden University.
 * verlof is free software.  See the file Copying for copying permission.
 *
 * $Revision: 1.5 $
 * $Date: 2003-01-29 09:19:20+01 $
 * $Source: \\\\fwneld\\msdos\\RCS\\K\\fsc\\prj\\verlof\\src\\register.js,v $
 * %Author: M.J. Moene %
 */

/*
 * $Header: \\\\fwneld\\msdos\\RCS\\K\\fsc\\prj\\verlof\\src\\register.js,v 1.5 2003-01-29 09:19:20+01 moene Exp $
 *
 * $Log: register.js,v $
 * Revision 1.5  2003-01-29 09:19:20+01  moene
 * <>
 *
 * Revision 1.4  2003/01/27 11:51:33  moene
 * added checks for number of hours.
 *
 * Revision 1.3  2003/01/06 11:28:24  moene
 * added sending e-mail from register.py.
 *
 * Revision 1.2  2002-12-12 16:00:48+01  moene
 * added check for valid hours input.
 *
 * Revision 1.1  2002/05/13 09:20:04  moene
 * Initial revision
 *
 */

/*
 * JavaScript compatibilty issues:
 *
 * Not supported		     Workaround
 * IE - undefined		     -1 used (dtio.js)
 * IE - RegExp.[left|right]Context   RegExp_leftContext(input)
 */

var previewWindow = null;		 // the preview window
var helpWindow	  = null;		 // the help window

var defaultName   = "uw naam";
var defaultEmail  = "uw e-mail adres";

/*
 * initialize - define form's initial settings.
 */

function initialize()
{
   var isEmpty = false;

   document.verlof.dbhost.value = dbhost;
   document.verlof.db.value	= db;
   document.verlof.mailto.value = mailto;

   // read from cookie:

   readName( document.verlof );
   readInfo( document.verlof );

   // if empty, draw attention:

   with ( document.verlof ) {
      if ( "" == email.value ) {
	 isEmpty = true;
	 email.value = defaultEmail;
	 email.select();
	 name.focus();
      }

      if ( "" == name.value ) {
	 isEmpty = true;
	 name.value = defaultName;
	 name.select();
	 name.focus();
      }

      if ( !isEmpty )
	 cat.focus();
   }

   return true;
}

/*
 * finalize - save information in cookies and close helpwindow.
 */

function finalize()
{
//alert( "finalize" );
   return writeName  ( document.verlof )
       && writeInfo  ( document.verlof )
       && closeWindow( previewWindow   )
       && closeWindow( helpWindow      );
}

/*
 * clearForm - clear fields.
 */

function clearForm()
{
   with ( document.verlof ) {
      date1.value   =
      date2.value   =
      hours.value   =
      remarks.value = "";
      cat.selectedIndex  = 0;
      part.selectedIndex = 0;
   }

   return true;
}

/*
 * changeCat - if space selected, select value above.
 */

function changeCat(obj)
{
   var s = obj.options[obj.selectedIndex].text.stripSpace();

   if ( '' == s )
      obj.selectedIndex = obj.selectedIndex -1;

   switch ( s )
   {
      case 'tegoed': case 'tegoed ADV': case 'transport':
	 form = obj.form;
	 form.date1.value = '1-1';
	 form.date2.value = '31-12';
	 form.hours.focus();
	 break;
      default:
	 break;
   }

   return true;
}

/*
 * leaveDate1 - if date specified, skip focus over calendar. [disabled]
 *
 * In some situations, skipping the field has the nasty side effects
 * that makes the wrong field to be selected, so it is more in the way
 * that that it is helpful.
 */

function leaveDate1(obj)
{
/*
   obj.value = obj.value.stripSpace();

   if ( '' != obj.value )
      obj.form.date2.focus();
*/
   return true;
}

/*
 * leaveDate2 - if date specified, skip focus over calendar. [disabled]
 *
 * In some situations, skipping the field has the nasty side effects
 * that makes the wrong field to be selected, so it is more in the way
 * that that it is helpful.
 */

function leaveDate2(obj)
{
/*
   obj.value = obj.value.stripSpace();

   if ( '' != obj.value )
      obj.form.hours.focus();
*/
   return true;
}

/*
 * leaveHours - disable daypart selection if hours is zero or less or more than 6.
 */

function leaveHours(obj)
{
//alert( 'leaveHours:' + obj.value );

   obj.value = obj.value.stripSpace();

   if ( ( hrs = obj.value ) != "" && hrs <= 0 || hrs > 6 )
   {
      obj.form.remarks.focus();
      obj.form.part.selectedIndex = 0;
      obj.form.part.disabled = true;
   }
   else
   {
      obj.form.part.disabled = false;
   }

   return true;
}

/*
 * previewForm - format information and save input as cookies for later use.
 */

function previewForm(aForm)
{
//alert('previewForm');
   if ( stripSpaces   ( aForm )
   &&	processName   ( aForm )
   &&	processCat    ( aForm )
   &&	processDate   ( aForm )
   &&	processHours  ( aForm )
   &&	processRemarks( aForm )
   &&	checkInfo     ( aForm )
   &&	writeName     ( aForm )
   &&	writeInfo     ( aForm ) )
   {
      startPreview();
      submitForm ( aForm, 'verlofregistratie_preview', 'get', submitPreview );
      focusWindow( previewWindow );

      return true;
   }

   return false
}

/*
 * processForm - process form
 *
 * check and format information, register information in database and send e-mail
 * and save input as cookies for later use.
 */

function processForm(aForm)
{
//alert('processForm');
   if ( stripSpaces   ( aForm )
   &&	processName   ( aForm )
   &&	processCat    ( aForm )
   &&	processDate   ( aForm )
   &&	processHours  ( aForm )
   &&	processRemarks( aForm )
   &&	checkInfo     ( aForm )
   &&	writeName     ( aForm )
   &&	writeInfo     ( aForm ) )
   {
      /*
       * NOTE:
       *
       * according to the JavaScript specification, target must be specified through a string,
       * it may not be specified via a variable or via an expression.
       *
       * Here we DO use a variable, there seems no problem in doing so.
       */

      submitForm( aForm, 'dump', 'post', submitRegister );    // POST only works for non-empty target

      /*
       * register.py informs user through a JavaScript alert.
       */

      self.close();	 // close this window

      return true;
   }

   return false;
}

/*
 * submitForm - submit form using method, action.
 */

function submitForm(aForm, target, method, action)
{
   aForm.target = target;	 // officially, target may only be specified via string, not via variable!
   aForm.method = method;
   aForm.action = action;
   aForm.submit();

   return true;
}

/*
 * informDone - inform user information has been sent.
 */

function informDone(aForm)
{
   alert( 'Het formulier is verzonden aan: \n\n' + mailto + '\n\n' + aForm.email.value );
   return true;
}

/*
 * stripSpaces - strip spaces surrounding info.
 */

function stripSpaces(aForm)
{
   with( aForm )
      var objs = new Array(
	 name,
	 email,
	 date1,
	 date2,
	 hours,
	 remarks
      );

   for( o in objs )
      objs[o].value = objs[o].value.stripSpace();

   return true;
}

/*
 * processName - build sortable name.
 *
 * Martin J. Moene -> Moene-MJ
 */

function processName(aForm)
{
//alert('processName');
   var n = new Name( aForm.name.value );

   aForm.name_srt.value = n.toString( '%s-%i' ).stripDash();
//   aForm.name_srt.value = n.toString( '%s-%i %p' ).stripDash();
   return true;
}

/*
 * processCat - build sortable name.
 */

function processCat(aForm)
{
   aForm.cat_txt.value = aForm.cat.options[aForm.cat.selectedIndex].text;
   return true;
}

/*
 * processDate - build various versions of dates.
 *
 * Subject: 2002.02.25
 * X-Info : 2002-02-25
 * Text   : ma 25 feb 2002
 */

function processDate(aForm)
{
//alert('processDate');
   /*
    * check for valid dates:
    */

   if ( null == ( date1 = scanDateMsg( aForm.date1.value, 'Begindatum' ) ) )
   {
      aForm.date1.focus();
      aForm.date1.select();
      return false;
   }

   /*
    * if date2 is not specified, copy it from date1:
    */

   if ( null == ( date2 = scanDateMsg( '' == aForm.date2.value ? aForm.date1.value : aForm.date2.value, 'Einddatum' ) ) )
   {
      aForm.date2.focus();
      aForm.date2.select();
      return false;
   }

   /*
    * format various dates:
    */

   aForm.date1_dot.value = strftime("%Y.%m.%d", date1 );
   aForm.date2_dot.value = strftime("%Y.%m.%d", date2 );
   aForm.date1_inf.value = strftime("%Y-%m-%d", date1 );
   aForm.date2_inf.value = strftime("%Y-%m-%d", date2 );
   aForm.date1_txt.value = strftime("%a %d %b %Y", date1 );
   aForm.date2_txt.value = strftime("%a %d %b %Y", date2 );

   parttext = aForm.part.options[aForm.part.selectedIndex].text;
   aForm.part_txt.value  = (parttext == "") ? "" : " " + parttext;

   return true;
}

/*
 * processHours - none.
 */

function processHours(aForm)
{
   aForm.hours.value = aForm.hours.value.replace( ',', '.' )

   return true;
}

/*
 * processRemarks - determine  if a remark is present.
 */

function processRemarks(aForm)
{
   if ( aForm.remarks.value != "" ) { aForm.remarks_inf.value = "*"; aForm.remarks_flg.value = "*"; }
   else 			    { aForm.remarks_inf.value = "-"; aForm.remarks_flg.value = ""; }

   return true;
}

/*
 * checkInfo - do several completeness and consistency checks.
 */

function checkInfo(aForm)
{
//alert('checkInfo');

   var date1   = scanDateMsg(	    aForm.date1.value, 'Begindatum' );
   var date2   = scanDateMsg( '' == aForm.date2.value ? aForm.date1.value : aForm.date2.value, 'Einddatum'  );

   var cat     = aForm.cat.options[aForm.cat.selectedIndex].text;
   var hours   = aForm.hours.value;
   var partndx = aForm.part.selectedIndex;

   if ( null == date1 || null == date2 )
   {
      message( 'onverwachte fout in begin en/of einddatum' );
   }

   /*
    * check for completeness:
    */

   else if ( (s = aForm.name.value) == defaultName || s == '' )
   {
      message( 'Wilt u uw naam invullen?' );
      aForm.name.focus();
      aForm.name.select();
   }

   else if ( (s = aForm.email.value) == defaultEmail || s == ''  )
   {
      message( 'Wilt u uw e-mail adres invullen?' );
      aForm.email.focus();
      aForm.email.select();
   }

   else if ( aForm.date1.value == "" && !confirm( 'Verlofregistratie:\n\nBegindatum is vandaag (leeg). Doorgaan?' ) )
   {
      aForm.date1.focus();
   }

   else if ( hours == "" )
   {
      message( 'Wilt u het aantal uren invullen?' );
      aForm.hours.focus();
   }

   else if ( isNaN( parseFloat(aForm.hours.value) ) )
   {
      message( 'Wilt u het aantal uren als getal invullen?  Bijvoorbeeld: 2.5' );
      aForm.hours.focus();
      aForm.hours.select();
   }

   else if ( cmpdate(date1, date2) == 0 && hours > 0 && hours <= 4 && aForm.part.selectedIndex == 0 )
   {
      message( 'Wilt u het dagdeel invullen?' );
      aForm.part.focus();
   }

   else if ( cat.indexOf("bijzonder") >= 0 && aForm.remarks.value == "" )
   {
      message( 'Verlofcategorie is bijzonder verlof. Wilt u een omschrijving geven?' );
      aForm.remarks.focus();
   }

   /*
    * check for consistency:
    */

   else if ( date1.getFullYear() != date2.getFullYear() )
   {
      message( 'Uw verlofopgave valt in twee jaren. Wilt u twee aparte opgaven doen?' );
      aForm.date2.focus();
      aForm.date2.select();
   }

   else if ( doCheckWeekday(cat) && ( 0 == ( day = date1.getDay() ) || 6 == day ) )
   {
      message( 'Begindatum valt in het weekeinde.' );
      aForm.date1.focus();
      aForm.date1.select();
   }

   else if ( doCheckWeekday(cat) && ( 0 == ( day = date2.getDay() ) || 6 == day ) )
   {
      message( 'Einddatum valt in het weekeinde.' );
      aForm.date2.focus();
      aForm.date2.select();
   }

   else if ( cmpdate(date1, date2) > 0 )
   {
		var tmp = aForm.date1.value;
      aForm.date1.value = aForm.date2.value;
      aForm.date2.value = tmp;

      message( 'Einddatum lag voor begindatum. Ik heb ze voor u verwisseld.' );
      aForm.date1.focus();
   }

   else if ( cmpdate(date1, date2) != 0 && partndx != 0 )
   {
      message( 'U geeft vm of nm op, terwijl het verlof zich uitstrekt over meer dan n dag.\nIk heb de dagdeelopgave gewist.' );
      aForm.part.focus();
      aForm.part.selectedIndex = 0;
   }

   // tegoed ADV (12 + 7 dg x 8hr = 152 hr)
   else if ( hours > 165 && cat.indexOf("tegoed ADV") >= 0 && !confirm( 'Verlofregistratie:\n\nHet aantal uren tegoed ADV dat u opgeeft is onverwacht groot. Doorgaan?' ) )
   {
      aForm.hours.focus();
      aForm.hours.select();
   }

   // tegoed (40wk x 5 dg x 8hr = 1600 hr)
   else if ( hours > 250 && cat.indexOf("tegoed") >= 0 && !confirm( 'Verlofregistratie:\n\nHet aantal uren tegoed dat u opgeeft is onverwacht groot. Doorgaan?' ) )
   {
      aForm.hours.focus();
      aForm.hours.select();
   }

   // transport: one year's tegoed at maximum
   else if ( hours > 250 && cat.indexOf("transport") >= 0 && !confirm( 'Verlofregistratie:\n\nHet aantal uren transport dat u opgeeft is onverwacht groot. Doorgaan?' ) )
   {
      aForm.hours.focus();
      aForm.hours.select();
   }

   // allow for 9 hours per day
   else if ( hours > 9 * workdays( date1, date2 ) && !confirm( 'Verlofregistratie:\n\nHet aantal uren dat u opgeeft is onverwacht groot. Doorgaan?' ) )
   {
      aForm.hours.focus();
      aForm.hours.select();
   }

   else if ( hours >= 6 && partndx != 0 )
   {
      message( 'U geeft vm of nm op, terwijl het aantal uren 6 of meer is.\nIk heb de dagdeelopgave gewist.' );
      aForm.part.focus();
      aForm.part.selectedIndex = 0;
   }

   else if ( hours <= 0 && partndx != 0 )
   {
       message( 'U geeft vm of nm op, terwijl het aantal uren nul of minder is.\nIk heb de dagdeelopgave gewist.' );
       aForm.part.focus();
       aForm.part.selectedIndex = 0;
   }

   else if ( hours <= 0 && aForm.remarks.value == "" )
   {
       message( 'Het aantal uren dat u opgeeft is nul of negatief. Wilt u een omschrijving geven?' );
       aForm.remarks.focus();
   }

   else if ( hours <= 0 && !confirm( 'Verlofregistratie:\n\nHet aantal uren dat u opgeeft is nul of negatief. Doorgaan?' ) )
   {
       aForm.hours.focus();
       aForm.hours.select();
   }
   else return true;

   return false;
}

/*
 * doCheckWeekday - return true if we must check if day is not sat/sun.
 */

function doCheckWeekday(cats)
{
   nocheck = new Array( 'tegoed', 'transport' );

   for ( i in nocheck )
      if ( cats.indexOf( nocheck[i] ) >= 0 )
	 return false;

   return true;
}

/*
 * scanDateMsg - parse date, issue message on error.
 */

function scanDateMsg( strng, msg )
{
   var dateResult = new scanDateResult();

   if ( null == ( dt = scanDate( strng, dateResult ) ) )
   {
      switch( dateResult.stat )
      {
	 case "daymonnon": message( msg + ': kan de juiste dag- of maandnaam niet bepalen (' + dateResult.estr + '); corrigeer datumopgave.' ); break;
	 case "daymonamb": message( msg + ': kan de juiste dag- of maandnaam niet bepalen (ambigu); geef meer letters op.' ); break;
	 case "dayamb"	 : message( msg + ': kan de juiste dagnaam niet bepalen (ambigu); geef meer letters op.' ); break;
	 case "monamb"	 : message( msg + ': kan de juiste maandnaam niet bepalen (ambigu); geef meer letters op.' ); break;
	 case "dayval"	 : message( msg + ': dag heeft een ongeldige waarde (' + dateResult.estr + '); corrigeer datumopgave.' ); break;
	 case "monval"	 : message( msg + ': maand heeft een ongeldige waarde(' + dateResult.estr + '); corrigeer datumopgave.' ); break;
	 default	 : message( msg + ': niet behandelde scanDate() foutcode (' + dateResult.stat + ')' ); break;
      }
   }

   return dt;
}

/*
 * message - build message with head and tail.
 */

function message(msg)
{
   alert( 'Verlofregistratie:\n\n' + msg + '\n\nHet formulier is niet verzonden.' );
   return false;
}

/*
 * cmpdate - date compare function, compares only year, month and date.
 *
 * the return value roughly indicates the difference in number of days.
 */

function cmpdate( d1, d2 )
{
   return ( d1.getFullYear() - d2.getFullYear() ) * 365
	+ ( d1.getMonth   () - d2.getMonth   () ) * 31
	+ ( d1.getDate	  () - d2.getDate    () );
}

/*
 * workdays- returns approximately the number of working days between two dates.
 */

function workdays( d1, d2 )
{
   var days = Math.abs( cmpdate( d1, d2 ) ) + 1

   return days - 2 * Math.floor( days / 7 )
}

/*
 * readName - load name from cookie.
 */

function readName( form )
{
//alert('readName()');

   form.name.value  = getCookie( "name"  );
   form.email.value = getCookie( "email" );
   return true;
}

/*
 * readInfo - load info from cookie.
 */

function readInfo( form )
{
//alert('readInfo()');

   form.cat.selectedIndex  =  getCookie( "cat"	   );
   form.date1.value	   =  getCookie( "date1"   );
   form.date2.value	   =  getCookie( "date2"   );
   form.hours.value	   =  getCookie( "hours"   );
   form.part.selectedIndex =  getCookie( "part"    );
   form.remarks.value	   =  getCookie( "remarks" );
   return true;
}

/*
 * writeName - register name for 1 year.
 */

function writeName( form )
{
   var today   = new Date();
   var expires = new Date();

   expires.setTime( today.getTime() + 1000*60*60*24*365*1);

   setCookie	  ( "name" , form.name.value , expires );
   setCookie	  ( "email", form.email.value, expires );

   return true;
}

/*
 * writeInfo - register info for 10 min.
 */

function writeInfo( form )
{
   var today   = new Date();
   var expires = new Date();

   expires.setTime( today.getTime() + 1000*60*10);

   setCookie	  ( "cat"    , form.cat.selectedIndex.toString() , expires);;
   setCookie	  ( "date1"  , form.date1.value , expires);
   setCookie	  ( "date2"  , form.date2.value , expires);
   setCookie	  ( "hours"  , form.hours.value , expires);
   setCookie	  ( "part"   , form.part.selectedIndex.toString(), expires);
   setCookie	  ( "remarks", form.remarks.value , expires);

   return true;
}

/*
 * startPreview - pop-up the previewscreen.
 */

function startPreview()
{
   if ( null == previewWindow || previewWindow.closed )
   {
      previewWindow = window.open( "null.html", "verlofregistratie_preview",
	 "dependent=yes,toolbar=no,directories=no,menubar=no,scrollbars,resizable=yes,width=500,height=250");
   }

//   focusWindow( previewWindow );

   return true;
}

/*
 * startHelp - pop-up the helpscreen.
 */

function startHelp()
{
   if ( null == helpWindow || helpWindow.closed )
   {
      helpWindow = window.open( regHelp, "verlofregistratieform_help",
	 "dependent=yes,toolbar=no,directories=no,menubar=no,scrollbars,resizable=yes,width=550,height=600");
   }

   focusWindow( helpWindow );

   return true;
}

/*
 * closeWindow - close window after checking that it exists and is not closed already.
 */

function closeWindow( hwnd )
{
   if ( null != hwnd && !hwnd.closed )
      hwnd.close();

   return true;
}

/*
 * focusWindow - focus window after checking that it exists and is not closed already.
 */

function focusWindow( hwnd )
{
   if ( null != hwnd && !hwnd.closed )
      hwnd.focus();

   return true;
}

/*
 * shortDateString - build date for form titlebar.
 */

var today = new Date();

function shortDateString()
{
//   return today.toString().substring(0, 16);
//   return strftime( "%a %d %b - %H:%M", today );
   return strftime( "%a %d %B %Y", today );
}

/*
 * end of file
 */

